#ifndef NDS_SOCKETS_H
#define NDS_SOCKETS_H

#include "daqc.h"

void socket_io_non_blocking( nds_socket_type Socket );
void socket_io_default ( nds_socket_type Socket );

#if _WIN32
typedef int socklen_t;

#define close(fd) closesocket(fd)
#define dup(oldfd) _dup(oldfd)
#define fdopen(path,mode) _fdopen(path,mode)
#define read(fd,buf,len) recv(fd,buf,len,0)
#define sleep(Seconds) Sleep(Seconds*1000)
#define strdup(str) _strdup(str)
#define usleep(MicroSeconds) Sleep(MicroSeconds/1000)
#define write(fd,buf,count) send(fd,buf,count,0)
#define perror( message ) nds_perror( message )
#else
#define strncpy_s(dest,dest_len,src,count) \
  strncpy(dest,src,count)
#define strcpy_s(dest,dest_len,src) \
  strcpy(dest,src)
#endif /* __WIN32__ */

#endif /* NDS_SOCKETS_H */
